
"""
TODO: Add this !!!
"""
from rest_framework import status
from rest_framework.views import APIView
from rest_framework import permissions
# from rest_framework.permissions import IsAuthenticated
from rest_framework.renderers import JSONRenderer
from rest_framework_simplejwt.authentication import JWTAuthentication
from django.views.decorators.http import require_GET
from django.contrib.auth import logout
from django.shortcuts import redirect
from django.http import JsonResponse


class TestOpenView(APIView):
    """Class for testing an end-point without authentication.
    """

    permission_classes = [permissions.AllowAny]

    def get(self, request=None, format=None):
        """Method for dealing with the GET requests done at this view.

        Parameters
        ----------
        request: rest_framework.request.Request
            The parameters from the GET request.
        format: None
            If some format was sent.

        Returns
        -------
        rest_framework.response.Response
            The response object.
        """

        ret_dict = {
            "error": False,
            "message": "This is the auth test open end-point"
        }

        return JsonResponse(ret_dict, status=status.HTTP_200_OK)


class TestClosedView(APIView):
    """Class for testing the authentication.
    """

    # permission_classes = [IsAuthenticated]
    authentication_classes = [JWTAuthentication]
    renderer_classes = [JSONRenderer]

    def get(self, request=None, format=None):
        """Method for dealing with the GET requests done at this view.

        Parameters
        ----------
        request: rest_framework.request.Request
            The parameters from the GET request.
        format: None
            If some format was sent.

        Returns
        -------
        rest_framework.response.Response
            The response object.
        """

        ret_dict = {
            "error": False,
            "message": "You are authenticated"
        }

        return JsonResponse(ret_dict, status=status.HTTP_200_OK)


# from rest_framework.response import Response
@require_GET
def custom_logout(request):
    """Method for logging out from django.

    Parameters
    ----------
    request: rest_framework.request.Request
        The parameters from the GET request.

    Returns
    -------
    redirect:
        Redirects to the login page.
    """

    logout(request)
    # return HttpResponse("You have been logged out.")  # Temporary for debugging
    return redirect('/auth/login/')
